#include "Asteroid.h"

CL_TexturePtr Asteroid::asteroidTexture[NUM_TEXTURES];
bool Asteroid::texturesLoaded = false;

// Constructor
Asteroid::Asteroid() {

	int speed = rand() % 50 + 25;
	// range   [[[[     0-50    ]  0-.5  ] -.25-.25] -.1-.1]
	dHeading = float(rand() % 50) / 100.0f - .25f * 3;
	heading = rand() % 360;
	texture = rand() % 3;

	pickRandomLocation();
	velocity.addVector(Vector2(heading, speed));

	asteroidID = -1; // Used for multiplayer
	size = 64.0f;
	asteroidSize = LARGE;
	alive = true;

	bound.setBoundingCircle(this, 60);

	if (!texturesLoaded) {
		asteroidTexture[0] = new CL_OpenGLSurface("Asteroids/big_1", WorldObject::manager);
		asteroidTexture[1] = new CL_OpenGLSurface("Asteroids/big_2", WorldObject::manager);
		asteroidTexture[2] = new CL_OpenGLSurface("Asteroids/big_3", WorldObject::manager);
		asteroidTexture[3] = new CL_OpenGLSurface("Asteroids/med_1", WorldObject::manager);
		asteroidTexture[4] = new CL_OpenGLSurface("Asteroids/med_2", WorldObject::manager);
		asteroidTexture[5] = new CL_OpenGLSurface("Asteroids/med_3", WorldObject::manager);
		asteroidTexture[6] = new CL_OpenGLSurface("Asteroids/sml_1", WorldObject::manager);
		asteroidTexture[7] = new CL_OpenGLSurface("Asteroids/sml_2", WorldObject::manager);
		asteroidTexture[8] = new CL_OpenGLSurface("Asteroids/sml_3", WorldObject::manager);

		texturesLoaded = true;
	}

	explosionParticles.setBaseObject(this);
}

// Destructor
Asteroid::~Asteroid() {
	//cout << "Asteroid Deleted\n";
}

void Asteroid::update(float timeScale) {

	x += (velocity*timeScale).getX();
	y += (velocity*timeScale).getY();
	heading += dHeading;

	explosionParticles.update(timeScale);
}

void Asteroid::paint() {

        WorldObject::glState->set_active();
	asteroidTexture[texture]->bind();
	paintOverlap();

	explosionParticles.paint();
}

void Asteroid::isHit() {
	alive = false;
	explosionParticles.burst(80);
};

void Asteroid::pickRandomLocation() {
	Vector2 startLocation(rand() % 360, rand() % 300+100);
	x = startLocation.getX(); y = startLocation.getY();
}
