#include "AsteroidArena.h"

AsteroidArena applicationInstance;

// Constructor
AsteroidArena::AsteroidArena() {}

// Destructor
AsteroidArena::~AsteroidArena() {}

int AsteroidArena::main(int, char **) {

	// Create a console window for text-output if not available
	CL_ConsoleWindow console("Console");
	console.redirect_stdio();

	try	{
		CL_SetupCore::init();
                CL_SetupDisplay::init();
		CL_SetupGL::init();
		CL_SetupNetwork::init();

		// Set display mode
                CL_DisplayWindow *window = new CL_DisplayWindow("Asteroid Arena", SCREENWIDTH,SCREENHEIGHT);
                CL_GraphicContext *gc = window->get_gc();
                WorldObject::glState = new CL_OpenGLState(gc);
                
                //window.set_fullscreen(SCREENWIDTH, SCREENHEIGHT, 32);
                cout << "loading" << endl;
		srand(CL_System::get_time());
/*
		while (true) {

			if (CL_Keyboard::get_keycode(CL_KEY_C)) {
				Client client;
				client.run();
				break;
			} 
			
			if (CL_Keyboard::get_keycode(CL_KEY_S)) {
				Server server;
				server.run();
				break;
			}

			if (CL_Keyboard::get_keycode(CL_KEY_G)) {
				Game game;
				game.run();
				break;
			} 
			CL_Display::flip();
			CL_System::sleep(10);
			CL_System::keep_alive();
		}
*/
		Game game;
		game.run();
		CL_SetupNetwork::deinit();
		CL_SetupDisplay::deinit();
		CL_SetupGL::deinit();
		CL_SetupCore::deinit();

	} catch (CL_Error err) {
		std::cout << "Exception caught: " << err.message.c_str() << std::endl;

		// Display console close message and wait for a key
		console.display_close_message();
	}

	return 0;
}
