#include "Global.h"

#ifndef FPS_H
#define FPS_H

// =============================================================================
// FPS is a simple counter to keep track of how many times the game is painted
// per second. update() returns the value and also updates the counter.
// =============================================================================

class FPS {

public:
	// =========================================================================
	// Functions
	// =========================================================================
	FPS() {
		lastSecond = CL_System::get_time();
		framesDisplayed = 0;
		framesDisplayedLast = 0;
	};

	int update() {

		framesDisplayed++;

		unsigned int time = CL_System::get_time();

		if (time > lastSecond + 1000) {
			framesDisplayedLast = framesDisplayed;
			framesDisplayed = 0;
			lastSecond = time;
		}

		return framesDisplayedLast;
	};

	// =========================================================================
	// Members
	// =========================================================================
	unsigned int lastSecond;
	int framesDisplayed, framesDisplayedLast;
};

#endif
//
