#ifndef GLOBAL_H
#define GLOBAL_H

#include <list>
#include <vector>

#include <ClanLib/core.h>
#include <ClanLib/display.h>
#include <ClanLib/application.h>
#include <ClanLib/gl.h>
#include <ClanLib/network.h>

// Util
#include "Message.h"
#include "SimpleList.h"
#include "FPS.h"
#include "Key.h"
#include "Vector2.h"

// World Objects

// Particles
#include "Particle.h"
#include "ParticleContainer.h"
#include "ExplosionParticleContainer.h"
#include "BulletParticleContainer.h"
#include "ExhaustParticleContainer.h"
#include "StarfieldParticleContainer.h"

#include "BoundCircle.h"
#include "WorldObject.h"
#include "Bullet.h"
#include "UFO.h"
#include "Special.h"
#include "Asteroid.h"
#include "Asteroids.h"
#include "Ship.h"

// Game
#include "GameScreen.h"
#include "Resource.h"
#include "Game.h"

// Network
/*
#include "NetMessage.h"
#include "NetShip.h"
#include "NetGame.h"
#include "Client.h"
#include "Server.h"
*/


using namespace std;

#define SCREENWIDTH 1024
#define SCREENHEIGHT 768

#endif
//
