#include "ParticleContainer.h"

// Constructor
ParticleContainer::ParticleContainer() {
	this->ratePerSecond = 0;
	time = 0;
	timeLastParticleAdded = 0;
	pointer = 0;
	active = false;
}

// Destructor
ParticleContainer::~ParticleContainer() {

}

void ParticleContainer::paintParticles() {
        WorldObject::glState->set_active();
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glTranslatef(SCREENWIDTH/2, SCREENHEIGHT/2, 0);

	glBlendFunc(GL_SRC_ALPHA, GL_ONE);

	glBegin(GL_QUADS);

	for (int i=0; i < USUAL_NUMBER_OF_PARTICLES; i++) {

		if (particles[i].lifeTimeRemaining <= 0) continue;
 
		glColor4f(particles[i].r, particles[i].g, particles[i].b, particles[i].a);
									
		glTexCoord2f(0,0); glVertex2f(-particles[i].size+particles[i].x, -particles[i].size+particles[i].y);
		glTexCoord2f(1,0); glVertex2f(particles[i].size+particles[i].x, -particles[i].size+particles[i].y);
		glTexCoord2f(1,1); glVertex2f(particles[i].size+particles[i].x, particles[i].size+particles[i].y);
		glTexCoord2f(0,1); glVertex2f(-particles[i].size+particles[i].x, particles[i].size+particles[i].y);
	}
		
	glEnd();	
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor3f(1, 1, 1);
}

bool ParticleContainer::hasNoAnimations() {

	for (int i=0; i < USUAL_NUMBER_OF_PARTICLES; i++) {

		if (particles[i].lifeTimeRemaining > 0) return false;

	}

	return true;

}

